> ## Documentation Index
> Fetch the complete documentation index at: https://developers.phonovation.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Add Person to Flow

> Creates or updates a person and adds it to Flow

**Required scope:** Enable one of: `flow:use`, `flow:manage`.



## OpenAPI

````yaml /openapi/phonovation-whatsapp.json post /communication/1/flows/{campaignId}/participants
openapi: 3.1.0
info:
  title: Phonovation Messaging APIs
  description: >-
    OpenAPI specification for Phonovation messaging, customer engagement, and
    platform APIs.
  contact:
    name: Phonovation support
    email: support@phonovation.com
  version: 3.250.0
  x-generatedAt: '2026-10-15T11:28:56.135064395Z'
servers:
  - url: https://api.messaging.phonovation.com
    description: Phonovation Messaging API production server
security: []
tags:
  - name: customer-engagement
    description: >
      Complete solutions that will help you drive better outcomes for your
      customers and business across the entire customer journey.
    x-type: category
    x-displayName: Customer Engagement
  - name: people
    description: >
      Build rich profiles for each person to create audience segments for more
      precise targeting. Manage duplicates and import your data over API.


      Events reflect actions that end users take on your website or in your
      mobile application.


      Events API is a robust way to send those events to Phonovation. Event can
      be sent only to an existing person in People module and an event
      definition should be created beforehand to describe contents of the event.


      Other events tracking options:

      * [ JavaScript SDK ](https://github.com/phonovation/people-web-sdk)

      * [iOS
      SDK](https://github.com/phonovation/mobile-messaging-sdk-ios/wiki/Events)

      * [Android
      SDK](https://github.com/phonovation/mobile-messaging-sdk-android/wiki/Events)
    x-type: product
    x-displayName: People
  - name: person-profile
    description: ''
    x-type: section
    x-displayName: Person profile
  - name: company-profile
    description: ''
    x-type: section
    x-displayName: Company profile
  - name: tags
    description: ''
    x-type: section
    x-displayName: Tags
  - name: custom-attributes
    description: ''
    x-type: section
    x-displayName: Custom attributes
  - name: custom-attributes-lists
    description: ''
    x-type: section
    x-displayName: 'Custom attributes: Lists'
  - name: contact-information:-push
    description: ''
    x-type: section
    x-displayName: 'Contact Information: Push'
  - name: events
    description: ''
    x-type: section
    x-displayName: Events
  - name: segments
    description: ''
    x-type: section
    x-displayName: Segments
  - name: moments
    description: >
      Use Moments to set up and manage automated messaging campaigns with your
      customers by building conversation workflows.
    x-type: product
    x-displayName: Moments
  - name: flow
    description: >
      [Flow](https://www.phonovation.com/docs/moments/manage-flow) is the
      Phonovation communication builder that helps you create and manage
      messaging campaigns. The Flows API allows you to add or remove people from
      communication programmatically for flows with an [active
      status](https://www.phonovation.com/docs/moments/manage-flow#launch-create).


      Use the Add Participants to flow endpoint to a person or batches of
      persons (between 1-1000 persons). The method works asynchronously to queue
      and process participants at a rate of 10 requests per second. For
      reporting of operation results, use the notifyUrl  field to provide a URL
      of your callback server that will receive a status report or use the Get a
      report on participants added to Flow endpoint.
    x-type: module
    x-displayName: Flow
  - name: conversations
    description: >-
      Conversations is a solution that allows Enterprises to engage in
      conversations with their customers over multiple channels. The solution is
      available either as a web-based cloud platform web interface or over HTTP
      API for 2-way messaging over SMS, WhatsApp, Viber, and Facebook messenger.
      It supports conversation threading, conversation management including
      queues and routing, agent assignment, resolution management and
      conversation history overview.
    x-type: product
    x-displayName: Conversations
  - name: conversation-management
    description: ''
    x-type: section
    x-displayName: Conversation management
  - name: conversation-tags
    description: ''
    x-type: section
    x-displayName: Conversation tags
  - name: conversation-messages
    description: ''
    x-type: section
    x-displayName: Conversation messages
  - name: conversation-events
    description: ''
    x-type: section
    x-displayName: Conversation events
  - name: conversation-notes
    description: ''
    x-type: section
    x-displayName: Conversation notes
  - name: conversation-agents
    description: ''
    x-type: section
    x-displayName: Conversation agents
  - name: conversation-queues
    description: ''
    x-type: section
    x-displayName: Conversation queues
  - name: conversation-routing
    description: ''
    x-type: section
    x-displayName: Conversation routing
  - name: bots
    description: ''
    x-type: section
    x-displayName: Bots
  - name: metadata
    description: ''
    x-type: section
    x-displayName: Metadata
  - name: templates
    description: ''
    x-type: section
    x-displayName: Templates
  - name: conversation-forms
    description: ''
    x-type: section
    x-displayName: Conversation forms
  - name: account-configuration
    description: ''
    x-type: section
    x-displayName: Account Configuration
  - name: agent-configuration-calls
    description: ''
    x-type: section
    x-displayName: Agent Configuration (Calls)
  - name: outbound-call-conversation-calls
    description: ''
    x-type: section
    x-displayName: Outbound Call Conversation (Calls)
  - name: waiting-strategies-calls
    description: ''
    x-type: section
    x-displayName: Waiting Strategies (Calls)
  - name: recording-configuration-calls
    description: ''
    x-type: section
    x-displayName: Recording Configuration (Calls)
  - name: recording-metadata-calls
    description: ''
    x-type: section
    x-displayName: Recording metadata (Calls)
  - name: recording-calls
    description: ''
    x-type: section
    x-displayName: Recording (Calls)
  - name: wrap-up-configuration-calls
    description: ''
    x-type: section
    x-displayName: Wrap Up Configuration (Calls)
  - name: wrap-up-time-calls
    description: ''
    x-type: section
    x-displayName: Wrap Up Time (Calls)
  - name: transfers-calls
    description: ''
    x-type: section
    x-displayName: Transfers (Calls)
  - name: transfer-to-external-number-configuration-calls
    description: ''
    x-type: section
    x-displayName: Transfer to External Number Configuration (Calls)
  - name: transfer-strategy-calls
    description: ''
    x-type: section
    x-displayName: Transfer Strategy (Calls)
  - name: call-hold-calls
    description: ''
    x-type: section
    x-displayName: Call Hold (Calls)
  - name: hold-configuration-calls
    description: ''
    x-type: section
    x-displayName: Hold Configuration (Calls)
  - name: call-timeout-calls
    description: ''
    x-type: section
    x-displayName: Call Timeout (Calls)
  - name: working-hours
    description: ''
    x-type: section
    x-displayName: Working Hours
  - name: tts-options-calls
    description: ''
    x-type: section
    x-displayName: TTS options (Calls)
  - name: away-audio-messages
    description: ''
    x-type: section
    x-displayName: Away Audio Messages
  - name: web-forms
    description: ''
    x-type: section
    x-displayName: Web Forms
  - name: answers
    description: >
      Answers is the Phonovation fully-encompassed chatbot building platform
      that enables you to build, test, and deploy highly customized chatbots of
      different types. Multiple channels are supported on Answers like WhatsApp,
      Facebook Messenger, Live Chat, Apple Business Chat, Viber, Google Business
      Messaging and other. Communication with Bot is achieved through existing
      Conversations solution infrastructure which enables integration and
      switching between communicating with bot and a live agent. Processing can
      start by receiving MO message or by receiving a trigger event. Users can
      manage bots (create, update, delete, start and stop bots) through a web
      interface. For more details, visit the [Answers
      documentation](https://www.phonovation.com/docs/answers).


      Answers API is in Early access stage.
    x-type: product
    x-displayName: Answers
  - name: answers-testing-start-test
    description: ''
    x-type: section
    x-displayName: Start Answers test
  - name: answers-testing-stop-test
    description: ''
    x-type: section
    x-displayName: Stop Answers test
  - name: answers-testing-send-message
    description: ''
    x-type: section
    x-displayName: Send inbound message to test
  - name: common-assets
    description: >
      Reuse assets created on Phonovation SaaS products in order to recreate
      configuration more easily on a single or across multiple accounts. Export
      or share Moments flows, Answers chatbots or other SaaS assets from your
      account and import it on another one.  


      This feature is in Early access stage.
    x-type: product
    x-displayName: Common Assets
  - name: saas-resource-export
    description: ''
    x-type: section
    x-displayName: Export resource
  - name: saas-resource-import
    description: ''
    x-type: section
    x-displayName: Import resource
  - name: saas-resource-share
    description: ''
    x-type: section
    x-displayName: Share resource
  - name: saas-status-request
    description: ''
    x-type: section
    x-displayName: Get SaaS request status
  - name: knowledge-base
    description: >-
      Knowledge Base is a centralized content management system for creating,
      organizing, and retrieving articles, attachments, and structured content.
      Content is organized into categories, folders, and a hierarchical content
      tree. Articles support draft and published workflow statuses, tagging,
      commenting, and file attachments.
    x-type: product
    x-displayName: Knowledge Base
  - name: knowledge-base-search
    description: ''
    x-type: section
    x-displayName: Search
  - name: knowledge-base-articles
    description: ''
    x-type: section
    x-displayName: Articles
  - name: knowledge-base-categories
    description: ''
    x-type: section
    x-displayName: Categories
  - name: knowledge-base-folders
    description: ''
    x-type: section
    x-displayName: Folders
  - name: knowledge-base-content-tree
    description: ''
    x-type: section
    x-displayName: Content Tree
  - name: knowledge-base-tags
    description: ''
    x-type: section
    x-displayName: Tags
  - name: knowledge-base-attachments
    description: ''
    x-type: section
    x-displayName: Attachments
  - name: ai-hub
    description: >
      AI-powered tools and services to help you create smarter and more
      personalized customer experiences.
    x-type: category
    x-displayName: AI Hub
  - name: ai-assistants
    description: >
      Phonovation AI assistant is a retrieval-augmented generation (RAG)
      solution that performs tasks based on documents and

      instructions you specify. This means the AI draws answers directly from
      your documents, resulting in more accurate

      and relevant responses. For more information on use cases and how to build
      AI assistants, visit our

      [AI Assistant](https://www.phonovation.com/docs/ai-hub/ai-assistant)
      product documentation.


      With AI Assistants API, you can:

      * Query your existing AI assistants created via [Phonovation
      Portal](https://www.phonovation.com/docs/ai-hub/ai-assistant/create-ai-assistant)

      * Retrieve context the AI assistant uses to answer your queries
    x-type: product
    x-displayName: AI Assistants
  - name: channels
    description: >
      Create a perfect customer experience by using the channels your customer
      already use and love.
    x-type: category
    x-displayName: Channels
  - name: sms
    description: >
      SMS (Short Message Service) is the most extensive messaging service
      available in terms of reach and coverage. A SMS can be sent to and from
      any mobile device in the world and does not necessarily require a data
      connection.


      Phonovation SMS API allows you to send and receive text messages (SMS),
      fetch or receive delivery reports on your endpoint in real time, and see
      message logs. You can send messages in different languages, schedule your
      messages, define delivery time window, and much more.


      To utilize SMS in combination with other channels, check out [Messages
      API](https://www.phonovation.com/docs/api/platform/messages-api).
    x-type: product
    x-displayName: SMS
  - name: outbound-sms
    description: >
      When you send an SMS to a phone number belonging to an end user's device
      you are sending an Outbound SMS. Historically, this was and still is
      referred to as a Mobile Terminated (MT) SMS, though nowadays an SMS is not
      always sent to a mobile device. In an Outbound SMS you can set the From or
      Sender field with whatever you have registered or purchased with
      Phonovation, either a Long Number, Short Code, or text based Sender.
    x-type: module
    x-displayName: Outbound SMS
  - name: send-message
    description: ''
    x-type: section
    x-displayName: Send a message
  - name: manage-scheduled-sms-messages
    description: ''
    x-type: section
    x-displayName: Manage Scheduled SMS Messages
  - name: confirm-conversion
    description: ''
    x-type: section
    x-displayName: Confirm conversion
  - name: inbound-sms
    description: >
      When an end user sends an SMS from their device to a Phone Number or Short
      Code they have sent an Inbound SMS. The Inbound SMS is routed to the
      Phonovation Platform and Phonovation in turn routes the SMS to its
      Customer who has purchased that Phone Number or Short Code. Inbound SMS,
      for historical reasons, are referred to as Mobile Originated (MO) SMS.
    x-type: module
    x-displayName: Inbound SMS
  - name: logs-and-status-reports
    description: >
      Status Reports tell you what happened to the SMS you sent, whether it was
      successfully delivered or failed to be delivered.

      They also provide timestamps, network information if available, and on SMS
      delivery failure, a status code indicating the reason. 

      Status Reports can be pushed in real-time to a Customer's webhook or can
      be retrieved by an API call. 

      Logs provide similar information to Status Reports but are available to
      query for 48hrs.
    x-type: module
    x-displayName: Logs and Status Reports
  - name: whatsapp
    description: >
      With 2 billion users, WhatsApp is the most used application worldwide. It
      enables you to reach more customers, sharing important and timely
      notifications, as well as provide real-time customer support. Phonovation
      is an official WhatsApp Business solution provider. Send and manage
      WhatsApp messages over Phonovation's WhatsApp API.


      To utilize WhatsApp in combination with other channels, check out
      [Messages
      API](https://www.phonovation.com/docs/api/platform/messages-api).


      [Learn more about WhatsApp channel and use
      cases](https://www.phonovation.com/docs/whatsapp).
    x-type: product
    x-displayName: WhatsApp
  - name: whatsapp-outbound-messages
    description: >
      When you send a WhatsApp message to a phone number belonging to an end
      user's device you are sending an outbound WhatsApp message. 

      There are several types of WhatsApp messages:
        - Template message – use a pre-defined template to send text, images, videos, share location, documents, attach buttons, and configure SMS failover.
        - Free-form text or media – use it only when contacted by the end user within a certain timeframe to send text, images, audio, video, stickers, share location, or contacts.
        - Interactive messages – send a message that your end user can interact with, such as interactive buttons, lists, or product messages.
    x-type: module
    x-displayName: Outbound messages
  - name: whatsapp-template-message
    description: ''
    x-type: section
    x-displayName: Template Message
  - name: whatsapp-text-and-media-messages
    description: ''
    x-type: section
    x-displayName: Text and media messages
  - name: send-whatsapp-interactive-messages
    description: ''
    x-type: section
    x-displayName: Interactive messages
  - name: whatsapp-events
    description: ''
    x-type: section
    x-displayName: Events
  - name: whatsapp-inbound-messages
    description: >
      When the end user sends a WhatsApp from their device to a phone number,
      they have sent an inbound WhatsApp message. 

      The inbound message is routed to the Phonovation Platform and Phonovation
      in turn routes the message to its customer who has registered the WhatsApp
      sender.

      Typical supporting features you’d use with inbound messages are:
        - Marking messages as read to communicate to the end user that you have read their message.
        - Downloading media and its metadata sent over by the end user.
    x-type: module
    x-displayName: Inbound messages
  - name: whatsapp-receive-inbound-message
    description: ''
    x-type: section
    x-displayName: Receive inbound message
  - name: whatsapp-get-inbound-media
    description: ''
    x-type: section
    x-displayName: Get inbound media
  - name: whatsapp-mark-message-as-read
    description: ''
    x-type: section
    x-displayName: Mark message as read
  - name: whatsapp-message-status-reports
    description: >
      Status Reports tell you what happened to the WhatsApp message you sent,
      whether it was successfully delivered or failed to be delivered, whether
      it’s been seen. 

      Status Reports can be pushed in real time to a customer's webhook or can
      be retrieved by an API call. 

      Logs provide similar information to Status Reports but are only available
      to query for 48hrs.

      There are a few reports you can set up for your WhatsApp messaging:
        - Delivery Reports - In case of a failure, you’ll receive a timestamp with a delivery failure message and a status code indicating the reason behind it.
        - Seen Reports – In case the message has been delivered successfully to the end user, this report will additionally inform you whether the message has been seen.
        - Payments - It provides all updates to your payment transaction in real time. It's also possible to fetch current state of the payment transaction in any time.
    x-type: module
    x-displayName: Message Status Reports
  - name: whatsapp-status-reports
    description: ''
    x-type: section
    x-displayName: Status Reports
  - name: whatsapp-payments
    description: ''
    x-type: section
    x-displayName: Payments
  - name: whatsapp-marketing-update
    description: ''
    x-type: section
    x-displayName: Marketing Update
  - name: whatsapp-service-management
    description: >
      As opposed to free-form messages, template messages can be sent and
      delivered at any time. 

      Here, you can manage your templates, from template registration,
      retrieving template statuses, to deleting existing templates.

      With each WhatsApp message, you can send various types of media. Here, you
      can manage your media and configure additional feature enhancing their
      functionality.

      Moreover you can fetch quality and business info of your senders.
    x-type: module
    x-displayName: Service Management
  - name: whatsapp-template-management
    description: ''
    x-type: section
    x-displayName: Template Management
  - name: whatsapp-flow-management
    description: ''
    x-type: section
    x-displayName: Flow Management
  - name: whatsapp-media-management
    description: ''
    x-type: section
    x-displayName: Media Management
  - name: whatsapp-sender-management
    description: ''
    x-type: section
    x-displayName: Sender Management
  - name: whatsapp-bulk-sender-registration
    description: ''
    x-type: section
    x-displayName: Bulk Sender Registration
  - name: whatsapp-identity-management
    description: >
      Set up identity change, an add-on available for senders hosted by
      Phonovation. This is supported for interactive buttons, interactive lists,
      or an interactive product message. 

      Identity change allows you to increase your security by preventing
      messages from being sent to unverified end users. 

      Once enabled for a sender, you would receive notifications when an end
      user's WhatsApp account (MSISDN) has potentially been transferred to a
      different user. 

      When a potential identity change has been detected, the outbound traffic
      towards that end user is blocked until you verify the user outside the
      channel and acknowledge the change.

      Contact your Account Executive for more information.
    x-type: module
    x-displayName: Identity Management
  - name: whatsapp-ad-conversions
    description: >
      The Conversions API for Business Messaging enables advertisers to
      consolidate web, app, physical store, and business messaging events into a
      single endpoint for Meta. With Phonovation, you can submit Purchase or
      LeadSubmitted conversion events for WhatsApp.
    x-type: module
    x-displayName: Ad Conversions
  - name: platform
    description: |
      Modular tools to scale and automate your business.
    x-type: category
    x-displayName: Platform
  - name: subscriptions-api
    description: >
      Subscriptions are a way to manage notifications sent to your webhooks by
      Phonovation.

      It is a useful feature if you want to narrow down the list of events to be
      notified about or specify different webhooks for different use cases.

      It will also allow you to set up authentication settings for your
      endpoint.


      If you want to use mutual TLS for the webhook that receives notification
      events from Phonovation, you can upload and manage a TLS certificate that
      Phonovation will use when connecting to your server. The certificate
      allows your server to verify that the request is really coming from
      Phonovation. For details, see [Create and Manage
      Certificates](https://www.phonovation.com/docs/cpaas-x/subscriptions-management/create-manage-subscriptions#create-and-manage-certificates).
    x-type: product
    x-displayName: Subscriptions Management
  - name: subscription
    description: ''
    x-type: section
    x-displayName: Subscription
  - name: profile
    description: ''
    x-type: section
    x-displayName: Profile
  - name: security
    description: ''
    x-type: section
    x-displayName: Security
  - name: certificate
    description: ''
    x-type: section
    x-displayName: Certificate
paths:
  /communication/1/flows/{campaignId}/participants:
    post:
      tags:
        - customer-engagement
        - moments
        - flow
      summary: Add Person to Flow
      description: |-
        Creates or updates a person and adds it to Flow

        **Required scope:** Enable one of: `flow:use`, `flow:manage`.
      operationId: add-people-to-flow
      parameters:
        - name: campaignId
          in: path
          description: Unique identifier of the flow that person will be added to
          required: true
          style: simple
          explode: false
          schema:
            type: integer
            format: int64
          example: 10159347
        - name: phone
          in: query
          description: Person's phone number
          required: false
          style: form
          explode: true
          schema:
            type: string
          example: 19123456789
        - name: email
          in: query
          description: Person's email address
          required: false
          style: form
          explode: true
          schema:
            type: string
          example: janewilliams@example.com
        - name: externalId
          in: query
          description: Unique ID for the person from an external system
          required: false
          style: form
          explode: true
          schema:
            type: string
          example: 8edb24b5-0319-48cd-a1d9-1e8bc5d577ab
      requestBody:
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.FlowPersonRequest
      responses:
        '200':
          description: OK
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.ExceptionResponse
        '401':
          $ref: '#/components/responses/ApiException401'
        '403':
          $ref: '#/components/responses/ApiException403'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.ExceptionResponse
        '500':
          $ref: '#/components/responses/ApiException500'
      deprecated: true
      security:
        - APIKeyHeader: []
components:
  schemas:
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.FlowPersonRequest:
      type: object
      description: >-
        Contains the data used for person creation (if it does not exist) or
        partial update (if it exists)
      example:
        personData:
          externalId: '1'
          firstName: Jane
          lastName: Smith
          address: 67 Farringdon Road
          city: London
          country: United Kingdom
          gender: FEMALE
          birthDate: '1966-01-15'
          middleName: Janie
          profilePicture: http://profile.com
          tags:
            - VIP Customers
            - New Customers
          customAttributes:
            Contract Expiry: '2018-06-01'
            Company: Acme
          contactInformation:
            phone:
              - number: '353861234579'
              - number: '353861234580'
            email:
              - address: jane@acme.com
              - address: janesmith@acme.com
        flowVariables:
          orderDate: '2021-09-01'
          orderDetails: Extended Weight, Discount
          orderNumber: 1234567
      properties:
        personData:
          type: 'null'
          allOf:
            - $ref: >-
                #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamPersonV2
        flowVariables:
          type:
            - object
            - 'null'
          additionalProperties:
            type: object
      required:
        - personData
      title: FlowPersonRequest
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.ExceptionResponse:
      type: object
      description: |-
        Response error codes

        <table>
        <tr><th>Error</th><th>ErrorCode</th><th>HTTP status</th></tr>
        <tr><td>Bad request</td><td>40001</td><td>400</td></tr>
        <tr><td>Duplicate person</td><td>40002</td><td>400</td></tr>
        <tr><td>Person manipulation failed</td><td>40003</td><td>400</td></tr>
        <tr><td>Person already in flow</td><td>40004</td><td>400</td></tr>
        <tr><td>Flow inactive</td><td>40005</td><td>400</td></tr>
        <tr><td>Person is not in the flow</td><td>40006</td><td>400</td></tr>
        <tr><td>Flow not found</td><td>40401</td><td>404</td></tr>
        <tr><td>Person not found</td><td>40402</td><td>404</td></tr>
        <tr><td>Action not found</td><td>40403</td><td>404</td></tr>
        <tr><td>Internal server error</td><td>50001</td><td>500</td></tr>
        </table>
      example:
        errorCode: 40001
        errorMessage: ''
      properties:
        errorCode:
          type: integer
          format: int32
        errorMessage:
          type: string
      title: Exception Response
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamPersonV2:
      type: object
      description: >-
        Person attributes. In case a person with either the specified
        <code>externalId</code> or <code>contactInformation</code> already
        exists in the People, the persons will be automatically merged. See <a
        href="https://www.phonovation.com/docs/api/customer-engagement/moments/add-flow-participants"
        target="_blank">endpoint description</a> for more info.
      properties:
        createdAt:
          type: string
          description: >-
            Date and time of creation. Has the following format:
            yyyy-MM-dd'T'HH:mm:ss.
          readOnly: true
        modifiedAt:
          type: string
          description: >-
            Date and time of last modification. Has the following format:
            yyyy-MM-dd'T'HH:mm:ss.
          readOnly: true
        id:
          type: integer
          format: int64
          description: Unique id of the entity.
          readOnly: true
        externalId:
          type: string
          description: >-
            Unique ID for a person from your or another external system, 256
            characters max.
        firstName:
          type: string
          description: Person's first name, 255 characters max.
        lastName:
          type: string
          description: Person's last name, 255 characters max.
        type:
          $ref: >-
            #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.PublicIamTypeV2
        address:
          type: string
          description: Person's title, 50 characters max.
        city:
          type: string
          description: Person's city, 50 characters max.
        country:
          type: string
          description: Person's country, 50 characters max.
        gender:
          $ref: >-
            #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamGender
        birthDate:
          type: string
          description: Person's date of birth, format `YYYY-MM-DD`.
        middleName:
          type: string
          description: Person's middle name, 50 characters max.
        preferredLanguage:
          type: string
          description: >-
            Person's preferred language. Must be in two letter ISO (xx) or
            language-region BCP-47 (xx-YY) format.
        profilePicture:
          type: string
          description: URL for the person's profile picture, 2083 characters max.
        origin:
          $ref: >-
            #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.PublicIamOrigin
        modifiedFrom:
          $ref: >-
            #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.PublicIamOrigin
        tags:
          type: array
          description: List of tags that this person has.
          items:
            type: string
            description: List of tags that this person has.
          uniqueItems: true
        customAttributes:
          type: object
          additionalProperties:
            type: object
          description: >-
            List of custom attributes for the person, 4096 characters max per
            value.
        contactInformation:
          $ref: >-
            #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamPersonContactsV2
        integrations:
          $ref: >-
            #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamIntegrationsV2
        computedAttributes:
          type: object
          additionalProperties:
            type: object
          description: Person's computed attributes grouped by type.
      title: IamPersonV2
    ApiException:
      type: object
      properties:
        requestError:
          $ref: '#/components/schemas/ApiRequestError'
      title: ApiException
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.PublicIamTypeV2:
      type: string
      description: Person's type, default type is CUSTOMER.
      enum:
        - CUSTOMER
        - LEAD
      title: PublicIamTypeV2
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamGender:
      type: string
      description: Person's gender.
      enum:
        - MALE
        - FEMALE
      title: IamGender
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.PublicIamOrigin:
      type: string
      description: >-
        The information which describes the source of the last modification of
        record.
      enum:
        - API
        - PORTAL
        - WEB_SDK
        - INTEGRATION
        - PUSH
        - FACEBOOK
        - LINE
        - TELEGRAM
        - SALESFORCE
        - DYNAMICS
        - ZAPIER
        - FORMS
        - COMPUTED
        - ANSWERS
        - CONVERSATIONS
      readOnly: true
      title: PublicIamOrigin
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamPersonContactsV2:
      type: object
      description: >-
        List of phones, emails and other information how a person can be
        contacted.
      properties:
        phone:
          type: array
          description: A list of person's phone numbers. Max 100 numbers per person.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamPhoneContact
        email:
          type: array
          description: A list of person's email addresses. Max 100 emails per person.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamEmailContact
        push:
          type: array
          description: List of person's push registrations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamPushContactV2
          readOnly: true
        facebook:
          type: array
          description: A list of person's Messenger destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact
          readOnly: true
        line:
          type: array
          description: A list of person's Line destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact
          readOnly: true
        viberBots:
          type: array
          description: A list of person's Viber Bots destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact
          readOnly: true
        liveChat:
          type: array
          description: A list of person's Live Chat destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact
          readOnly: true
        instagram:
          type: array
          description: A list of person's Instagram destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact
          readOnly: true
        telegram:
          type: array
          description: A list of person's Telegram destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact
          readOnly: true
        appleBusinessChat:
          type: array
          description: A list of person's Apple Business Chat destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact
          readOnly: true
        webpush:
          type: array
          description: A list of person's web push destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonPushContact
          readOnly: true
        instagramDm:
          type: array
          description: A list of person's Instagram DM destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact
          readOnly: true
        kakaoSangdam:
          type: array
          description: A list of person's Kakao Sangdam destinations.
          items:
            $ref: >-
              #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact
          readOnly: true
      title: IamPersonContactsV2
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamIntegrationsV2:
      type: object
      description: Integrations.
      properties:
        salesforce:
          $ref: >-
            #/components/schemas/900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamSalesforceV2
      title: IamIntegrationsV2
    ApiRequestError:
      type: object
      properties:
        serviceException:
          $ref: '#/components/schemas/ApiRequestErrorDetails'
      title: ApiRequestError
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamPhoneContact:
      type: object
      description: A list of person's phone numbers. Max 100 numbers per person.
      properties:
        number:
          type: string
          description: >-
            Person's phone number. Must be in [international
            format](https://en.wikipedia.org/wiki/E.164) and cannot exceed 50
            characters. One person can have up to 100 phone numbers.
      title: IamPhoneContact
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamEmailContact:
      type: object
      description: A list of person's email addresses. Max 100 emails per person.
      properties:
        address:
          type: string
          description: >-
            Person's email address. Must comply with the [email
            format](https://tools.ietf.org/html/rfc2822) and cannot exceed 255
            characters. One person can have up to 100 email addresses.
      title: IamEmailContact
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamPushContactV2:
      type: object
      description: List of person's push registrations.
      properties:
        applicationId:
          type: string
          description: Application Id on which the user is subscribed.
          readOnly: true
        registrationId:
          type: string
          description: Push registration ID.
          readOnly: true
        additionalData:
          type: object
          additionalProperties:
            type: object
            readOnly: true
          description: Unique user ID for a person.
          readOnly: true
        systemData:
          type: object
          additionalProperties:
            type: object
            readOnly: true
          description: System data collected from the user's profile.
          readOnly: true
        isPrimary:
          type: boolean
          description: >-
            Set to true if this device is a primary device of a user among other
            devices.
          readOnly: true
      readOnly: true
      title: IamPushContactV2
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonOttContact:
      type: object
      description: A list of person's Kakao Sangdam destinations.
      properties:
        applicationId:
          type: string
          description: Application Id on which the user is subscribed.
          readOnly: true
        userId:
          type: string
          description: Unique user ID for a person.
          readOnly: true
        systemData:
          type: object
          additionalProperties:
            type: object
            readOnly: true
          description: System data collected from the user's profile.
          readOnly: true
      readOnly: true
      title: CommonOttContact
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.CommonPushContact:
      type: object
      description: A list of person's web push destinations.
      properties:
        applicationId:
          type: string
          description: Application Id on which the user is subscribed.
          readOnly: true
        registrationId:
          type: string
          description: Push registration ID.
          readOnly: true
        additionalData:
          type: object
          additionalProperties:
            type: object
            readOnly: true
          description: Unique user ID for a person.
          readOnly: true
        systemData:
          type: object
          additionalProperties:
            type: object
            readOnly: true
          description: System data collected from the user's profile.
          readOnly: true
      readOnly: true
      title: CommonPushContact
    900634339512041dd9c6cd5c4ad62d6cf43ea57e0548f5deeceb9f79d92b92f0.IamSalesforceV2:
      type: object
      description: Salesforce integration.
      properties:
        leadId:
          type: string
          description: Salesforce lead id.
        contactId:
          type: string
          description: Salesforce contact id.
      title: IamSalesforceV2
    ApiRequestErrorDetails:
      type: object
      properties:
        messageId:
          type: string
          description: Identifier of the error.
        text:
          type: string
          description: Detailed error description.
        validationErrors:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
              description: Validation errors.
          description: Validation errors.
      title: ApiRequestErrorDetails
  responses:
    ApiException401:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiException'
          example:
            requestError:
              serviceException:
                messageId: UNAUTHORIZED
                text: Unauthorized
        application/xml:
          schema:
            $ref: '#/components/schemas/ApiException'
          example: |
            <?xml version="1.0" encoding="UTF-8"?><ApiException>
              <requestError>
                <serviceException>
                  <messageId>UNAUTHORIZED</messageId>
                  <text>Unauthorized</text>
                </serviceException>
              </requestError>
            </ApiException>
    ApiException403:
      description: Forbidden
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiException'
          example:
            requestError:
              serviceException:
                messageId: FORBIDDEN
                text: Forbidden
        application/xml:
          schema:
            $ref: '#/components/schemas/ApiException'
          example: |
            <?xml version="1.0" encoding="UTF-8"?><ApiException>
              <requestError>
                <serviceException>
                  <messageId>FORBIDDEN</messageId>
                  <text>Forbidden</text>
                </serviceException>
              </requestError>
            </ApiException>
    ApiException500:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiException'
          example:
            requestError:
              serviceException:
                messageId: GENERAL_ERROR
                text: Something went wrong. Please contact support.
        application/xml:
          schema:
            $ref: '#/components/schemas/ApiException'
          example: |
            <?xml version="1.0" encoding="UTF-8"?><ApiException>
              <requestError>
                <serviceException>
                  <messageId>GENERAL_ERROR</messageId>
                  <text>Something went wrong. Please contact support.</text>
                </serviceException>
              </requestError>
            </ApiException>
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      description: >
        This is the most secure authorization type and the one with the most
        flexibility.


        API keys can be generated by calling the dedicated API method.
        Furthermore, API keys can have a limited scope and cover only some API
        methods. Lastly, they can

        be revoked at any time. This range of possibilities makes API keys well
        suited for separating the API access rights across multiple applications
        or use cases.

        Finally, the loss of an API key is easily manageable.


        You can manage your API keys from
        [GUI](https://portal.phonovation.com/settings/accounts/api-keys), or
        programmatically

        with [dedicated API](#platform-&-connectivity/settings).


        API key Authorization header example:


        ```shell

        Authorization: App
        003026bbc133714df1834b8638bb496e-8f4b3d9a-e931-478d-a994-28a725159ab9

        ```
      name: Authorization
      in: header
      x-default: 'App '

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.